%global distro  stillOS
%define release_name    The Becoming
%global still_major 0
%global minor   0
%global base_major   10
%global base_minor 0
%global base_ver %{base_major}.%{base_minor}
%global eol_date 2035-06-01
%global beta Beta

Name:           stillos-release
Version:        %{still_major}.%{base_major}%{base_minor}.%{minor}
Release:        14.7.1%{?dist}
Summary:        %{distro} release files
License:        GPL-2.0-or-later
URL:            https://stillhq.io

# Needed to provide compatibility with the Alma Linux base
Provides:       almalinux-release = %{base_major}.%{base_minor}
Conflicts:      almalinux-release
Obsoletes:      almalinux-release
Provides:       almalinux-release-eula = %{base_major}.%{base_minor}
Conflicts:      almalinux-release-eula
Obsoletes:      almalinux-release-eula

Provides:       centos-release = %{base_major}.%{base_minor}
# When running a compose for ELN, we want to make sure that we pull in the
# correct templates when lorax is installed. This Suggests: will clue
# libdnf to use this set of templates instead of lorax-templates-generic.
Suggests:       lorax-templates-almalinux

# Required for a lorax run (to generate install media)
Requires:       almalinux-repos = %{base_major}.%{base_minor}
Provides:       centos-release-eula
Provides:       redhat-release-eula

# required by epel-release
Provides:       redhat-release = %{base_major}.%{base_minor}

# required by dnf
# https://github.com/rpm-software-management/dnf/blob/4.2.23/dnf/const.py.in#L26
Provides:       system-release = %{base_major}.%{base_minor}
Provides:       system-release(releasever) = %{base_major}
Conflicts:      system-release

# required by libdnf
# https://github.com/rpm-software-management/libdnf/blob/0.48.0/libdnf/module/ModulePackage.cpp#L472
Provides:       base-module(platform:el%{base_major})

Source200:      EULA
Source201:      LICENSE

Source300:      85-display-manager.preset
Source301:      90-default.preset
Source302:      90-default-user.preset
Source303:      99-default-disable.preset
Source304:      50-redhat.conf

Source400:      alsecureboot001.cer
Source500:      still-stillos-alma.repo

Source600:      RPM-GPG-KEY-AlmaLinux-10

Source700:      https://dl.fedoraproject.org/pub/epel/epel-release-latest-%{base_major}.noarch.rpm

%package -n stillos-sb-certs
Summary: %{distro} public secureboot certificates
Group: System Environment/Base
Provides: almalinux-sb-certs = %{base_ver}-%{release}
Provides: system-sb-certs = %{base_ver}-%{release}
Provides: redhat-sb-certs = %{base_ver}-%{release}
Provides: centos-sb-certs = %{base_ver}-%{release}
Provides: almalinux-sb-certs = %{base_ver}-%{release}

%package -n stillos-repos
Summary:        %{distro} package repositories
Requires:       almalinux-repos = %{base_ver} 
Requires:       almalinux-release = %{base_ver}-%{release}
Requires:       almalinux-gpg-keys = %{base_ver}-%{release}
# Required by CentOS SIGs release packages
Provides:       centos-stream-repos = %{base_ver}-%{release}

# Provides EPEL Release
# because otherwise it uses an invalid releasever
Provides:       epel-release

%package -n stillos-gpg-keys
Summary:        %{distro} RPM keys
# Required by CentOS SIGs release packages
Provides:       almalinux-gpa-keys = %{base_ver}-%{release}
Provides:       centos-gpg-keys = %{base_ver}-%{release}

%description
%{distro} release files.

%description -n stillos-sb-certs
%{distro} secureboot certificates

%description -n stillos-repos
This package provides the package repository files for %{distro}.

%description -n stillos-gpg-keys
This package provides the RPM signature keys for %{distro}.

%install
# copy license and contributors doc here for %%license and %%doc macros
mkdir -p ./docs
cp %{SOURCE201} ./docs

# create /etc/system-release and /etc/redhat-release
install -d -m 0755 %{buildroot}%{_sysconfdir}
echo "%{distro} %{still_major} (%{release_name} %{still_major}A%{base_major}%{base_minor}R%{minor})" > %{buildroot}%{_sysconfdir}/stillos-release
ln -s stillos-release %{buildroot}%{_sysconfdir}/almalinux-release
ln -s stillos-release %{buildroot}%{_sysconfdir}/system-release
ln -s stillos-release %{buildroot}%{_sysconfdir}/redhat-release

# -------------------------------------------------------------------------
# Definitions for /etc/os-release and for macros in macros.dist.  These
# macros are useful for spec files where distribution-specific identifiers
# are used to customize packages.

# Name of vendor / name of distribution. Typically used to identify where
# the binary comes from in --help or --version messages of programs.
# Examples: gdb.spec, clang.spec
%global dist_vendor stillHQ
%global dist_name   %{distro}

# URL of the homepage of the distribution
# Example: gstreamer1-plugins-base.spec
%global dist_home_url https://stillhq.io/

# Bugzilla / bug reporting URLs shown to users.
# Examples: gcc.spec
# TODO: Change this to future stillHQ bug report url
%global dist_bug_report_url https://bugs.almalinux.org/

# debuginfod server, as used in elfutils.spec.
# %global dist_debuginfod_url https://debuginfod.centos.org/
# -------------------------------------------------------------------------

# Create the os-release file
install -d -m 0755 %{buildroot}%{_prefix}/lib
cat > %{buildroot}%{_prefix}/lib/os-release << EOF
NAME="%{dist_name}"
VERSION="%{still_major} (%{release_name} A%{base_major}%{base_minor}R%{minor})"
ID="stillos"
ID_LIKE="almalinux rhel centos fedora"
VERSION_ID="%{still_major}A%{base_major}%{base_minor}R%{minor}"
PLATFORM_ID="platform:el%{base_major}"
PRETTY_NAME="%{distro} %{still_major} (%{release_name})"
ANSI_COLOR="0;94"
LOGO=stillos-logo-icon
CPE_NAME="cpe:/o:stillos:stillos:%{still_major}A%{base_major}%{base_minor}R%{minor}::baseos"
HOME_URL="%{dist_home_url}"
DOCUMENTATION_URL="https://stillhq.io/"
VENDOR_NAME="stillHQ"
VENDOR_URL="%{dist_home_url}"
BUG_REPORT_URL="%{dist_bug_report_url}"
DEFAULT_HOSTNAME="stillos%{still_major}"

ALMALINUX_MANTISBT_PROJECT="AlmaLinux-%{base_major}"
ALMALINUX_MANTISBT_PROJECT_VERSION="%{base_major}.%{base_minor}"
REDHAT_SUPPORT_PRODUCT="%{distro}"
REDHAT_SUPPORT_PRODUCT_VERSION="%{base_major}.%{base_minor}%{?beta: %{beta}}"
SUPPORT_END=%{eol_date}
EOF

# Create the symlink for /etc/os-release
ln -s ../usr/lib/os-release %{buildroot}%{_sysconfdir}/os-release

# write cpe to /etc/system/release-cpe
echo "cpe:/o:almalinux:almalinux:%{base_major}::baseos" > %{buildroot}%{_sysconfdir}/system-release-cpe

# create /etc/issue, /etc/issue.net and /etc/issue.d
echo '\S' > %{buildroot}%{_sysconfdir}/issue
echo 'Kernel \r on an \m' >> %{buildroot}%{_sysconfdir}/issue
cp %{buildroot}%{_sysconfdir}/issue{,.net}
echo >> %{buildroot}%{_sysconfdir}/issue
mkdir -p %{buildroot}%{_sysconfdir}/issue.d

# set up the dist tag macros
mkdir -p %{buildroot}%{_rpmmacrodir}
cat > %{buildroot}%{_rpmmacrodir}/macros.dist << EOF
# dist macros.

%%__bootstrap ~bootstrap
%%stillos_ver %{still_major}A%{base_major}%{base_minor}R%{minor}
%%stillos  %{still_major}A%{base_major}%{base_minor}R%{minor}
%%almalinux_ver %{base_major}
%%almalinux %{base_major}
%%centos_ver %{base_major}
%%centos %{base_major}
%%rhel %{base_major}
%%el%{base_major} 1
%%distcore            .el%{base_major}
%%dist %%{!?distprefix0:%%{?distprefix}}%%{expand:%%{lua:for i=0,9999 do print("%%{?distprefix" .. i .."}") end}}%%{distcore}%%{?distsuffix}%%{?with_bootstrap:%{__bootstrap}}
%%dist_vendor         %{dist_vendor}
%%dist_name           %{dist_name}
%%dist_home_url       %{dist_home_url}
%%dist_bug_report_url %{dist_bug_report_url}
EOF

# use unbranded datadir
install -d -m 0755 %{buildroot}%{_datadir}/stillos-release
ln -s stillos-release %{buildroot}%{_datadir}/almalinux-release
ln -s stillos-release %{buildroot}%{_datadir}/redhat-release
install -p -m 0644 %{SOURCE200} %{buildroot}%{_datadir}/stillos-release/

# copy systemd presets
install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/user-preset
install -p -m 0644 %{SOURCE300} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -p -m 0644 %{SOURCE301} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -p -m 0644 %{SOURCE302} %{buildroot}%{_prefix}/lib/systemd/user-preset/

# installing the same file for both system and user presets to set the same behavior for both
install -p -m 0644 %{SOURCE303} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -p -m 0644 %{SOURCE303} %{buildroot}%{_prefix}/lib/systemd/user-preset/

# copy sysctl presets
mkdir -p %{buildroot}/%{_prefix}/lib/sysctl.d/
install -m 0644 %{SOURCE304} %{buildroot}/%{_prefix}/lib/sysctl.d/

# Create stub yum repos
mkdir %{buildroot}%{_sysconfdir}/yum.repos.d
# touch %{buildroot}%{_sysconfdir}/yum.repos.d/redhat.repo

# Copy secureboot certificates
install -d -m 0755 %{buildroot}%{_sysconfdir}/pki/sb-certs/
install -d -m 0755 %{buildroot}%{_datadir}/pki/sb-certs/

# Install aarch64 certs
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-aarch64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-aarch64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-grub2-aarch64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-fwupd-aarch64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-aarch64.cer

# Install x86_64 certs
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-x86_64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-x86_64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-grub2-x86_64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-fwupd-x86_64.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-x86_64.cer

# Install ppc64le certs
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-ppc64le.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-ppc64le.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-grub2-ppc64le.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-ppc64le.cer

# Install s390x certs
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-s390x.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-s390x.cer
install -m 644 %{SOURCE400} %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-s390x.cer

# Link x86_64 certs
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-x86_64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-ca-x86_64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-x86_64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-kernel-x86_64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-grub2-x86_64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-grub2-x86_64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-fwupd-x86_64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-fwupd-x86_64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-x86_64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-uki-virt-x86_64.cer

# Link aarch64 certs
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-aarch64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-ca-aarch64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-aarch64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-kernel-aarch64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-grub2-aarch64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-grub2-aarch64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-fwupd-aarch64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-fwupd-aarch64.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-aarch64.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-uki-virt-aarch64.cer

# Link ppc64le certs
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-ppc64le.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-ca-ppc64le.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-ppc64le.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-kernel-ppc64le.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-grub2-ppc64le.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-grub2-ppc64le.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-ppc64le.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-uki-virt-ppc64le.cer

# Link s390x certs
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-ca-s390x.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-ca-s390x.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-kernel-s390x.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-kernel-s390x.cer
ln -sr %{buildroot}%{_datadir}/pki/sb-certs/secureboot-uki-virt-s390x.cer %{buildroot}%{_sysconfdir}/pki/sb-certs/secureboot-uki-virt-s390x.cer

# THIS PACKAGE DOESNT PROVIDE ALMA REPOS SO COMMENTED OUT
# copy yum repos
# install -d -m 0755 %{buildroot}%{_sysconfdir}/yum.repos.d
# install -p -m 0644 %{SOURCE500} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE501} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE502} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE503} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE504} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE505} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE506} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE507} %{buildroot}%{_sysconfdir}/yum.repos.d/
# # RT and NFV are only for x86_64
# %ifarch x86_64
# install -p -m 0644 %{SOURCE510} %{buildroot}%{_sysconfdir}/yum.repos.d/
# install -p -m 0644 %{SOURCE511} %{buildroot}%{_sysconfdir}/yum.repos.d/
# %endif

install -p -m 0644 %{SOURCE500} %{buildroot}%{_sysconfdir}/yum.repos.d/

# Replace basearch to x86_64_v2
# %ifarch x86_64_v2
# sed -i "s/\$basearch/x86_64_v2/g" %{buildroot}%{_sysconfdir}/yum.repos.d/*.repo
# sed -i '/^mirrorlist=/ s|$|?arch=x86_64_v2|g' %{buildroot}%{_sysconfdir}/yum.repos.d/*.repo
# %endif

# Replace $releasever variable with beta if it is set
# %if %{defined beta}
# sed -i "s/\$releasever/%{major}.%{minor}-beta/g" %{buildroot}%{_sysconfdir}/yum.repos.d/*.repo
# sed -i "s|https://repo.almalinux.org/almalinux/|https://vault.almalinux.org/|g" %{buildroot}%{_sysconfdir}/yum.repos.d/*.repo
# %endif

# dnf variables
# install -d -m 0755 %{buildroot}%{_sysconfdir}/dnf/vars
# echo "%{base_major}-stream" > %{buildroot}%{_sysconfdir}/dnf/vars/stream

# copy GPG keys
install -d -m 0755 %{buildroot}%{_sysconfdir}/pki/rpm-gpg
install -p -m 0644 %{SOURCE600} %{buildroot}%{_sysconfdir}/pki/rpm-gpg/

# These variables should be set in the build environment to change rpm names
mkdir -p %{buildroot}%{_sysconfdir}/rpm
%ifarch x86_64_v2
echo '%%_target_platform x86_64-%%{_vendor}-%%{_target_os}%%{?_gnu}' >> %{buildroot}%{_sysconfdir}/rpm/macros.x86_64_v2
echo '%%x86_64_v2 1' >> %{buildroot}%{_sysconfdir}/rpm/macros.x86_64_v2
%endif

# Packaging EPEL Release into stillos-release
rpm2cpio %{SOURCE700} | cpio -idmv -D %{buildroot}

# Replace macros in epel.repo
sed -i 's|^name=.*\$releasever.*\$basearch|name=Extra Packages for Enterprise Linux %{base_major} - %{_basearch}|g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel.repo
sed -i 's|\${releasever_minor:+-z}||g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel.repo
sed -i 's|^metalink=.*\$releasever&arch=\$basearch|metalink=https://mirrors.fedoraproject.org/metalink?repo=epel-%{base_major}&arch=%{_basearch}|g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel.repo
sed -i 's|RPM-GPG-KEY-EPEL-\$releasever_major|RPM-GPG-KEY-EPEL-%{base_major}|g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel.repo

# Replace macros in epel-testing.repo (if needed)
sed -i 's|^name=.*\$releasever.*\$basearch|name=Extra Packages for Enterprise Linux %{base_major} - %{_basearch}|g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel-testing.repo
sed -i 's|\${releasever_minor:+-z}||g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel-testing.repo
sed -i 's|^metalink=.*\$releasever&arch=\$basearch|metalink=https://mirrors.fedoraproject.org/metalink?repo=epel-testing-%{base_major}&arch=%{_basearch}|g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel-testing.repo
sed -i 's|RPM-GPG-KEY-EPEL-\$releasever_major|RPM-GPG-KEY-EPEL-%{base_major}|g' %{buildroot}%{_sysconfdir}/yum.repos.d/epel-testing.repo


%files
%license docs/LICENSE
%{_sysconfdir}/stillos-release
%{_sysconfdir}/redhat-release
%{_sysconfdir}/system-release
%{_sysconfdir}/almalinux-release
%config(noreplace) %{_sysconfdir}/os-release
%config %{_sysconfdir}/system-release-cpe
%config(noreplace) %{_sysconfdir}/issue
%config(noreplace) %{_sysconfdir}/issue.net
%dir %{_sysconfdir}/issue.d
%dir %{_sysconfdir}/yum.repos.d
%ghost %{_sysconfdir}/yum.repos.d/redhat.repo
%{_rpmmacrodir}/macros.dist
%{_datadir}/stillos-release
%{_datadir}/redhat-release
%{_datadir}/almalinux-release
%{_prefix}/lib/os-release
%{_prefix}/lib/systemd/system-preset/*
%{_prefix}/lib/systemd/user-preset/*
%{_prefix}/lib/sysctl.d/50-redhat.conf
%ifarch x86_64_v2
%config(noreplace) %{_sysconfdir}/rpm/macros.x86_64_v2
%endif

%files -n stillos-sb-certs
# Note to future packagers:
# resetting the symlinks in /etc/pki/sb-certs on upgrade is the intended behavior here
%dir %{_sysconfdir}/pki/sb-certs
%dir %{_datadir}/pki/sb-certs/
%{_sysconfdir}/pki/sb-certs/*.cer
%{_datadir}/pki/sb-certs/*.cer

%files -n stillos-repos
%{_datadir}/licenses/epel-release/GPL-2.0-only.txt
%config(noreplace) %{_sysconfdir}/yum.repos.d/still-stillos-alma.repo
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-EPEL-%{base_major}
%config(noreplace) %{_sysconfdir}/yum.repos.d/epel.repo
%config(noreplace) %{_sysconfdir}/yum.repos.d/epel-testing.repo
%{_prefix}/lib/systemd/system-preset/90-epel.preset
%{_bindir}/crb

%files -n stillos-gpg-keys
%{_sysconfdir}/pki/rpm-gpg

%changelog
* Tue Apr 1 2025 Cameron Knauff <cameron@stillhq.io> - 0.10.0
- Modify Alma 10 release for stillOS 0

* Mon Nov 25 2024 Eduard Abdullin <eabdullin@almalinux.org> - 10.0-14.4
- Initial release
